NbKL = 4096;
epsilon = eps;
source("affichage.m");
colormap(gray(256));

### Lecture des images
images_fic = fopen('train-images-idx3-ubyte', 'rb', 'ieee-be');

entete = fread(images_fic, 4, 'int32');
if entete(1) != 2051
  disp(sprintf('[Attention] Le nombre magique ne correspond pas (%d != %d).',
               entete(1), 2051));
endif
disp(sprintf('[Info] Le fichier contient %d images %d*%d.', ...
             entete(2), entete(3), entete(4)));
taille = entete(3);

images = fread(images_fic, [taille * taille, NbKL])';

fclose(images_fic);

saveimage("chiffres.ppm", Affiche_matrice(images, 10), "ppm");

### Vecteurs propres
moyenne = mean(images);
variance = std(images) + epsilon;

images_norm = (images - repmat(moyenne, NbKL, 1)) ./ repmat(variance, \
                                                            NbKL, 1);

[vep, vap] = eig(cov(images_norm));
[vap_rangees, indices] = sort(-diag(vap));

permut = zeros(taille * taille);

for i=1:taille * taille,
  permut(indices(i), i) = 1;
endfor

base_proj = vep * permut;

saveimage("propres.ppm", Affiche_matrice(128 + 1024 * base_proj',
                                         4, 4, 3), "ppm");

### Projection sur DimProj vecteurs propres
DimProj = 16;

transformee = images_norm * base_proj;
saveimage("projetes.ppm", Affiche_matrice(128 + 128 * transformee, 10, 10, 8, DimProj), "ppm");

### Lecture des etiquettes
etiquettes_fic = fopen('train-labels-idx1-ubyte', 'rb', 'ieee-be');
entete = fread(etiquettes_fic, 2, 'int32');
if entete(1) != 2049
  disp(sprintf('[Attention] Le nombre magique ne correspond pas (%d != %d).', entete(1), 2053));
endif

etiquettes = fread(etiquettes_fic, [NbKL, 1], 'uchar');

fclose(etiquettes_fic);

### Chiffres moyens
[etiq, ind] = sort(etiquettes);

debut(1) = 1;
for i = 1:NbKL - 1,
  if etiq(i) < etiq(i + 1)
    fin(etiq(i) + 1) = i;
    debut(etiq(i + 1) + 1) = i + 1;
  endif
endfor
fin(10) = NbKL;

moy_reel = zeros(10, taille * taille);
moy_proj = zeros(10, DimProj);

for chif = 1:10,
  indices = ind(debut(chif) : fin(chif));
  moy_reel(chif, :) = mean(images(indices, :));

  moy_transf = mean(images_norm(indices, :)) * base_proj;
  moy_proj(chif, :) = moy_transf(1:DimProj);
endfor

saveimage("chif_moy.ppm", Affiche_matrice(moy_reel, 10, 1, 1), "ppm");
saveimage("proj_moy.ppm", Affiche_matrice(128 + 128 * moy_proj, 10, 1, 8), "ppm");

# DimProj = 64;
# moy_proj = zeros(10, DimProj);
# for chif = 1:10,
#   indices = ind(debut(chif) : fin(chif));
#   moy_transf = base_proj' * mean(images_norm(indices, :))';
#   moy_proj(chif, :) = moy_transf(1:DimProj)';
# endfor
# saveimage("proj_moy.ppm", Affiche_matrice(128 + 128 * moy_proj, 10, 1, 8), "ppm");

### Quantite d'info conservee

automatic_replot              = false;
gset terminal x11
gset terminal epslatex
plot(100 * cumsum(vap_rangees) ./ sum(vap_rangees), ";;");
axis([1,taille * taille, 0, 100]);
xlabel("Dimension de la base de projection");
ylabel('[]{\\shortstack{Pourcentage d\'information\\\\ contenue dans le projet}}');
gset output "info.eps"
replot
gset terminal x11

### Projection et reconstruction

for DimProj = [16, 36, 100],
  saveimage(sprintf("recons_%d.ppm", DimProj),
            Affiche_matrice(repmat(variance, NbKL, 1) .*
                            (base_proj * [transformee(:,1:DimProj), zeros(NbKL, taille * taille - DimProj)]')'
                            + repmat(moyenne, NbKL, 1), 10) ,"ppm");
endfor
